diff --git a/src/backend/storage/ipc/signalfuncs.c b/src/backend/storage/ipc/signalfuncs.c
index 6e310b14eb..c0ae8948ea 100644
--- a/src/backend/storage/ipc/signalfuncs.c
+++ b/src/backend/storage/ipc/signalfuncs.c
@@ -19,6 +19,7 @@
 #include "catalog/pg_authid.h"
 #include "miscadmin.h"
 #include "pgstat.h"
+#include "postmaster/interrupt.h"
 #include "postmaster/syslogger.h"
 #include "storage/pmsignal.h"
 #include "storage/proc.h"
@@ -253,6 +254,8 @@ pg_reload_conf(PG_FUNCTION_ARGS)
 		PG_RETURN_BOOL(false);
 	}
 
+	ConfigReloadPending = true;
+
 	PG_RETURN_BOOL(true);
 }
 
